// Application : jhnSetup
// jhnIniSection.prg , Created : 2009/06/24   06:18 PM

#using System.Collections.Generic
#using System.Xml
#using System.Xml.Serialization

BEGIN NAMESPACE jhnFT.Utils.Config

	SEALED CLASS jhnSectionItems
		PROTECT aItems AS SortedList<STRING, STRING>

		CONSTRUCTOR()
			SELF:aItems := SortedList<STRING, STRING>{}
		RETURN

		ACCESS Items AS SortedList<STRING, STRING>
			RETURN SELF:aItems

		METHOD PutItem(cName AS STRING, cValue AS STRING) AS VOID
			LOCAL cVal AS STRING
			cName := cName:ToLower()
			IF SELF:aItems:TryGetValue(cName, cVal)
				SELF:aItems[cName] := cValue
			ELSE
				SELF:aItems:Add(cName, cValue)
			ENDIF
		RETURN

		METHOD GetItem(cName AS STRING) AS STRING
			LOCAL value AS STRING
			IF !SELF:aItems:TryGetValue(cName:ToLower(), value)
				value := ""
			ENDIF
		RETURN value

		METHOD GetItems() AS STRING[]
			LOCAL nItem AS INT
			LOCAL sItems AS STRING[]
			sItems := STRING[]{SELF:aItems:Count}
			FOR nItem := 0 UPTO SELF:aItems:Count - 1
				sItems[nItem] := SELF:aItems:Keys[nItem] + "=" + SELF:aItems:Values[nItem]
			NEXT
		RETURN sItems

		METHOD IsEntry(sEntry AS STRING) AS LOGIC
			LOCAL nIndex AS INT
			SELF:aItems:IndexOfKey(sEntry:ToLower())
		RETURN nIndex >= 0

	END CLASS

END NAMESPACE

