// Application : ddFramework
// ddMenuItem.prg , Created : 2014/11/26   08:26 PM
// User : Johan

#using System.Windows.Forms
#using jhnFT.Utils.Config

INTERNAL ABSTRACT CLASS jhnMenuItemBase INHERIT ToolStripMenuItem
	PROTECT nID, nOwnerID AS INT

	CONSTRUCTOR()
		SUPER()
	RETURN

	PROPERTY Class_No AS INT
		GET
			RETURN SELF:nID
		END GET
	END PROPERTY

	PROPERTY Owner_No AS INT
		GET
			RETURN SELF:nID
		END GET
	END PROPERTY

	PROTECTED METHOD MenuItemClick(o AS OBJECT, e AS EventArgs) AS VOID
		LOCAL oPC AS jhnParameterCollection[]
		LOCAL cnt AS INT
		oPC := jhnSetupDict.Inst:ClassMemberGet(((jhnMenuItemBase)o):Class_No)
		cnt := oPC:Length - 1
		IF cnt >= 0
			FOR LOCAL i := 0 AS INT UPTO cnt
				LOCAL obj AS OBJECT
				obj := jhnMemberInterface.Inst:MemberAdd(oPC[i])
				IF obj:GetType():IsSubclassOf(typeof(Form))
					((jhnMenuItemBase)o):ChangeEnabledStatus()
					BEGIN SCOPE
						LOCAL oForm AS Form
						oForm := (Form)obj
						oForm:FormClosed += FormClosedEventHandler{(jhnMenuItemBase)o , @MenuEventChangeEnabledStatus()}
						oForm:Show()
					END SCOPE
				ELSE
					MessageBox.Show(((ToolStripMenuItem)o):Text:Replace("&", ""))
				ENDIF
			NEXT
		ELSE
			MessageBox.Show(((ToolStripMenuItem)o):Text:Replace("&", ""))
		ENDIF
	RETURN

	PROTECTED METHOD MenuEventChangeEnabledStatus(o AS OBJECT, e AS FormClosedEventArgs) AS VOID
		SELF:ChangeEnabledStatus()
	RETURN

	HIDDEN METHOD ChangeEnabledStatus() AS VOID
		SELF:Enabled := !SELF:Enabled
	RETURN

	PROTECTED METHOD MenuItemProcess(o AS OBJECT) AS VOID
		IF o:GetType():IsSubclassOf(typeof(ToolStripItem))
			SELF:MenuItemAdd((ToolStripItem)o)
		ELSE
			MessageBox.Show("Unable to process object\n\nObject type\t: " + o:GetType():ToString(), SELF:GetType():ToString() + ":MenuItemProcess(o)")
		ENDIF
	RETURN

	PROTECTED METHOD MenuItemAdd(o AS ToolStripItem) AS VOID
		IF o:GetType():IsSubclassOf(typeof(ToolStripMenuItem)) && !((ToolStripMenuItem)o):HasDropDown
			((ToolStripMenuItem)o):Click += EventHandler{SELF, @MenuItemClick()}
		ENDIF
		SELF:DropDown:Items:Add(o)
	RETURN

	PROTECTED METHOD MenuClose(o AS OBJECT, e AS EventArgs) AS VOID
		MessageBox.Show(e"Thank you for using the application\nHope to see you soon again\n\n" + SELF:Text:Replace("&", ""))
		Application.Exit()
	RETURN

END CLASS

CLASS jhnMenuItem INHERIT jhnMenuItemBase

	CONSTRUCTOR(p AS jhnParameterCollection)
		SUPER()
		SELF:nID := p:GetInt("member_no")
		SELF:nOwnerID := p:GetInt("class_no")
		SELF:Name := p:Get("member_id")
		SELF:Text := p:Get("text")
		IF SELF:nOwnerID > 0
			IF SELF:Name:ToLower():StartsWith("applist")
				SELF:InitializeAppMenuItem()
			ELSE
				SELF:InitializeMenuItem()
			ENDIF
		ENDIF
	RETURN

	METHOD InitializeMenuItem() AS VOID
		LOCAL delMIAdd AS MemAdd
		delMIAdd := MemAdd{SELF, @MenuItemProcess()}
		TRY
			jhnMemberInterface.Inst:MemberAdd(SELF:nID, delMIAdd)
		CATCH ex AS Exception
			MessageBox.Show(ex:Message, SELF:GetType():ToString())
		END TRY
	RETURN

	METHOD InitializeAppMenuItem() AS VOID
		LOCAL delMIAdd AS MemAdd
		delMIAdd := MemAdd{SELF, @MenuItemProcess()}
		TRY
			BEGIN SCOPE
				LOCAL p, oAPC AS jhnParameterCollection
				LOCAL iCls AS INT[]
				LOCAL iCnt AS INT
				iCls := jhnSetupDict.Inst:LkpItemGet("application")
				iCnt := iCls:Length - 1
				FOR LOCAL i := 0 AS INT UPTO iCnt
					p := jhnSetupDict.Inst:ClassPropertyGet(iCls[i])
					oAPC := jhnParameterCollection{}
					oAPC:Add("classmember_no", (i * -1):ToString())
					oAPC:Add("class_no", "0")
					oAPC:Add("seq", i:ToString())
					oAPC:Add("member_no", p:Get("class_no"))
					oAPC:Add("member_id", p:Get("class_id"))
					oAPC:Add("membertype_no", p:Get("classtype_no"))
					oAPC:Add("membertype_id", p:Get("classtype_id"))
					oAPC:Add("text", p:Get("text"))
					oAPC:Add("defaultclass", SELF:GetType():ToString())
					jhnMemberInterface.Inst:MemberAdd(oAPC, delMIAdd)
				NEXT
			END SCOPE
		CATCH ex AS Exception
			MessageBox.Show(ex:Message, SELF:GetType():ToString())
		END TRY
	RETURN

END CLASS

