// Application : visualFrame
// jhnParameterCollection.prg , Created : 2008-08-10   08:18:16 AM
#using System
#using System.Windows.Forms

CLASS jhnParameterCollection INHERIT System.Collections.Specialized.NameValueCollection

	CONSTRUCTOR() 
		SUPER()
	RETURN

	METHOD AddFromEAVString(cStr AS STRING) AS VOID
		LOCAL sSplit, sSub AS STRING[]
		LOCAL nCnt AS INT
		sSplit := cStr:Split(";":ToCharArray(), StringSplitOptions.RemoveEmptyEntries)
		FOR nCnt := 0 UPTO sSplit:Length - 1
			IF sSplit[nCnt]:Contains("=")
				sSub := sSplit[nCnt]:Split("=":ToCharArray())
				TRY
					SELF:Add(sSub[0]:ToLower(), sSub[1]:Replace("$eq$", "="))
				CATCH oEx AS Exception
					MessageBox.Show(cStr + "(" + nCnt:ToString() + ")" + e"\n" + oEx:Message, ProcName())
					SELF:DisplayMembers()
				END TRY
			ENDIF
		NEXT
	RETURN

	METHOD GetInt(strName AS STRING) AS INT
		LOCAL nRet AS INT
		nRet := Int16.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetWord(strName AS STRING) AS WORD
		LOCAL nRet AS WORD
		nRet := UInt16.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetDWord(strName AS STRING) AS DWORD
		LOCAL nRet AS DWORD
		nRet := UInt32.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetLong(strName AS STRING) AS LONG
		LOCAL nRet AS LONG
		nRet := Int32.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetReal4(strName AS STRING) AS REAL4
		LOCAL nRet AS REAL4
		nRet := Single.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetReal8(strName AS STRING) AS REAL8
		LOCAL nRet AS REAL8
		nRet := Double.Parse(SELF:Get(strName))
	RETURN nRet

	METHOD GetDecimal(strName AS STRING) AS Decimal
		LOCAL nRet AS Decimal
		nRet := Decimal.Parse(SELF:Get(strName):Replace(",", ""))
	RETURN nRet

	METHOD GetBoolean(strName AS STRING) AS LOGIC
		LOCAL lBoolean AS LOGIC
		LOCAL strRet := SELF:Get(strName):Replace(" ", "") AS STRING
		IF strRet:Length > 0
			 lBoolean := "_t_true_y_yes_1_":Contains("_" + strRet + "_")
		ENDIF
	RETURN lBoolean

	METHOD HasKey(cKey AS STRING) AS LOGIC
	RETURN Array.IndexOf(SELF:AllKeys, cKey) >= 0

	METHOD Put(strName AS STRING, strVal AS STRING) AS STRING
		LOCAL sOld AS STRING
		strName := strName:ToLower()
		sOld := SELF:Get(strName)
		IF sOld = NULL
			sOld := ""
		ENDIF
		SUPER:Set(strName, strVal)
	RETURN sOld

	METHOD ProcessSql(strSql AS STRING) AS STRING
		LOCAL nTel AS WORD 
		LOCAL strName AS STRING
		LOCAL strValue AS STRING
		FOR nTel := 0 TO SELF:Count - 1
			strName := SELF:GetKey(nTel)
			strValue := SELF:Get(strName)
			IF strValue:Length=0
				strValue := "NULL" 
			ENDIF
			strSql := strSql:Replace("#" + strName + "#", strValue)	
		NEXT
		strSql := strSql:Replace("'NULL'", "NULL")
	RETURN strSql

	METHOD DisplayMembers() AS VOID
		SELF:DisplayMembers(ProcName(1) + "(" + ProcLine(1):ToString() + ")")
	RETURN

	METHOD DisplayMembers(cTxt AS STRING) AS VOID
		LOCAL cStr AS STRING
		LOCAL nItem AS INT
		cStr := ""
		FOR nItem := 0 TO SELF:Count - 1
			cStr += SELF:GetKey(nItem) + ":" + SELF:Get(nItem) + e"\n"
		NEXT
		MessageBox.Show(cStr, cTxt)
	RETURN

END CLASS

