// Application : visualFrame
// SetupDict.prg , Created : 2008/07/10   09:15:30 PM

#using System.Collections.Generic
#using System.Windows.Forms
//#using System.Data
#using System.Collections.Specialized
#using System.Collections.ObjectModel
#using System.IO
#using jhnFT.Utils.Config

BEGIN NAMESPACE jhnFT.Utils.Config

	DELEGATE PropertyGet(s AS STRING) AS OBJECT
	DELEGATE PropertyPut(s AS STRING, o AS OBJECT) AS VOID
	DELEGATE ClassMemberGet(i AS INT) AS jhnParameterCollection[]

	INTERNAL SEALED CLASS jhnSetupDict
		STATIC HIDDEN _inst AS jhnSetupDict
		HIDDEN lstProperties AS SortedList<STRING, OBJECT>
		HIDDEN oLkpDef, oLkpItem, oClass, oMember AS IntKeyParCollection
		HIDDEN oSLkpDef, oSLkpItem, oSClass, oSMember AS StrKeyedIntListCollection

		STATIC CONSTRUCTOR()
			_inst := jhnSetupDict{}
		RETURN

		HIDDEN CONSTRUCTOR()
			SUPER()
			SELF:InitializeDict()
		RETURN

		STATIC PROPERTY Inst AS jhnSetupDict
			GET
				RETURN _inst
			END GET
		END PROPERTY

		HIDDEN METHOD InitializeDict() AS VOID
			LOCAL oIni AS jhnIniFile

			SELF:lstProperties := SortedList<STRING, OBJECT>{}
			SELF:lstProperties:Add("ExeFullName", Application.ExecutablePath)
			SELF:lstProperties:Add("ExeName", Path.GetFileName((STRING)SELF:lstProperties["ExeFullName"]):Replace(Path.GetExtension((STRING)SELF:lstProperties["ExeFullName"]), ""))
			SELF:lstProperties:Add("ExePath", Application.StartupPath + "\")
			SELF:lstProperties:Add("StartPath", Application.StartupPath)
			SELF:lstProperties:Add("FrameworkIni", (STRING)SELF:lstProperties["ExeFullName"] + ".ini")
			SELF:lstProperties:Add("PropertyGet", PropertyGet{SELF, @PropertyGet()})
			SELF:lstProperties:Add("PropertyPut", PropertyPut{SELF, @PropertyPut()})
			SELF:lstProperties:Add("MemberGet", ClassMemberGet{SELF, @ClassMemberGet()})

			SELF:oLkpDef := IntKeyParCollection{"lkpdef_no"}
			SELF:oLkpItem := IntKeyParCollection{"lkpitem_no"}
			SELF:oClass := IntKeyParCollection{"class_no"}
			SELF:oMember := IntKeyParCollection{"classmember_no"}

			SELF:oSLkpDef := StrKeyedIntListCollection{}
			SELF:oSLkpItem := StrKeyedIntListCollection{}
			SELF:oSClass := StrKeyedIntListCollection{}

			oIni := jhnIniFile{(STRING)SELF:lstProperties["FrameworkIni"]}
/*			BEGIN SCOPE
				LOCAL iApp AS INT
				IF oIni:IsEntry("start", "class")
					iApp := oIni:GetInt("start", "class")
				ELSE
					iApp := 0
				ENDIF
				SELF:lstProperties:Add("Start", KeyValuePair<INT, STRING>{iApp, "application"})
			END SCOPE
*/
			FOREACH section AS STRING IN <STRING>{"lkpdef", "lkpitem", "class", "classmember"}
				LOCAL aItem AS STRING[]
				aItem := oIni:GetSection(section)
				FOREACH str AS STRING IN aItem
					LOCAL oPC, oPCS AS jhnParameterCollection
					LOCAL sName, type AS STRING
TRY
					str := section + "_no=" + str:Replace("=", ";"):Replace(":", "=")
					oPC := jhnParameterCollection{}
					oPC:AddFromEAVString(str)

					sName := section + "_id"
					IF section == "lkpdef"
						SELF:oLkpDef:Add(oPC)
						SELF:oSLkpDef:Add(StrKeyIntList{oPC:Get(sName)})
					ELSEIF section == "lkpitem"
						oPC:Add("lkpdef_id", type := SELF:oLkpDef[oPC:GetInt("lkpdef_no")]:Get("lkpdef_id"))
						SELF:oLkpItem:Add(oPC)
						SELF:oSLkpItem:Add(StrKeyIntList{oPC:Get(sName)})
						SELF:oSLkpDef[type]:Add(oPC:GetInt("lkpitem_no"))
					ELSEIF section == "class"
						oPCS := SELF:oLkpItem[oPC:GetInt("classtype_no")]
						oPC:Add("classtype_id", type := oPCS:Get("lkpitem_id"))
						IF !oPC:HasKey("defaultclass")
							oPC:Add("defaultclass", oPCS:Get("defaultclass"))
						ENDIF
						SELF:oClass:Add(oPC)
						SELF:oSClass:Add(StrKeyIntList{oPC:Get("class_id")})
						SELF:oSLkpItem[type]:Add(oPC:GetInt("class_no"))
					ELSEIF section == "classmember"
						oPC:Add("class_id", SELF:oClass[oPC:GetInt("class_no")]:Get("class_id"))
						oPC:Add("member_id", SELF:oClass[oPC:GetInt("member_no")]:Get("class_id"))
						oPC:Add("membertype_id", SELF:oLkpItem[oPC:GetInt("membertype_no")]:Get("lkpitem_id"))
						oPC:Add("defaultclass", SELF:oLkpItem[oPC:GetInt("membertype_no")]:Get("defaultclass"))
						IF !oPC:HasKey("text")
							IF SELF:oClass[oPC:GetInt("class_no")]:HasKey("text")
								oPC:Add("text", SELF:oClass[oPC:GetInt("class_no")]:Get("text"))
							ENDIF
						ENDIF
						SELF:oMember:Add(oPC)
						SELF:oSClass[oPC:Get("class_id")]:Add(oPC:GetInt("classmember_no"))
					ELSE
						MessageBox.Show("Unknown section : "+ section)
						System.Windows.Forms.Application.Exit()
					ENDIF
CATCH ex AS Exception
	MessageBox.Show(str + e"\n" + ex:Message)
END TRY
				NEXT
			NEXT
		RETURN

		INTERNAL METHOD LkpItemGet(s AS STRING) AS INT[]
			LOCAL iSerial AS INT[]
			SELF:oSLkpItem:TryGetValue(s, iSerial)
		RETURN iSerial

		INTERNAL METHOD LkpItemGet(i AS INT) AS jhnParameterCollection
			LOCAL oPC AS jhnParameterCollection
			IF SELF:oLkpItem:Contains(i)
				oPC := SELF:oLkpItem[i]
			ENDIF
		RETURN oPC

		INTERNAL METHOD ClassPropertyGet(i AS INT) AS jhnParameterCollection
			LOCAL oPC AS jhnParameterCollection
			IF SELF:oClass:Contains(i)
				oPC := SELF:oClass[i]
			ENDIF
		RETURN oPC

		INTERNAL METHOD ClassMemberGet(i AS INT) AS jhnParameterCollection[]
			LOCAL aPC AS jhnParameterCollection[]
			LOCAL lst := List<jhnParameterCollection>{} AS List<jhnParameterCollection>
			LOCAL aMbr AS INT[]
			aMbr := SELF:oSClass[SELF:oClass[i]:Get("class_id")]:@@Value
			FOR LOCAL mbr := 0 AS INT UPTO aMbr:Length - 1
				LOCAL prop AS jhnParameterCollection
				prop := SELF:oMember[aMbr[mbr]]
				IF prop:GetInt("class_no") = i
//					prop:DisplayMembers("ClassMemberGet " + i:ToString())
					lst:Add(prop)
				ENDIF
			NEXT
			aPC := lst:ToArray()
		RETURN aPC

		INTERNAL METHOD PropertyGet(n AS STRING) AS OBJECT
			LOCAL o AS OBJECT
			SELF:lstProperties:TryGetValue(n, o)
		RETURN o
 
		INTERNAL METHOD PropertyPut(n AS STRING, o AS OBJECT) AS VOID
			// Do nothing at this level, everything is fixed at this level
		RETURN

	END CLASS

	CLASS IntKeyParCollection INHERIT KeyedCollection<INT, jhnParameterCollection>
		HIDDEN sKey AS STRING

		INTERNAL PROPERTY KeyName AS STRING
			GET
				RETURN SELF:sKey
			END GET
		END PROPERTY

		CONSTRUCTOR(k AS STRING)
			SUPER()
			SELF:sKey := k
		RETURN

		PROTECTED METHOD GetKeyForItem(o AS jhnParameterCollection) AS INT
		RETURN o:GetInt(SELF:sKey)

	END CLASS

	CLASS IntKeyedIntListCollection INHERIT KeyedCollection<INT, IntKeyIntList>

		CONSTRUCTOR()
			SUPER()
		RETURN

		PROTECTED METHOD GetKeyForItem(itm AS IntKeyIntList) AS INT
		RETURN itm:Key

	END CLASS

	CLASS StrKeyedIntListCollection INHERIT KeyedCollection<STRING, StrKeyIntList>

		CONSTRUCTOR()
			SUPER()
		RETURN

		PROTECTED METHOD GetKeyForItem(itm AS StrKeyIntList) AS STRING
		RETURN itm:Key

		INTERNAL METHOD TryGetValue(k AS STRING, i REF INT[]) AS LOGIC
			LOCAL val AS StrKeyIntList
			LOCAL tgv AS LOGIC
			tgv := SELF:Dictionary:TryGetValue(k, val)
			i := val:@@Value
		RETURN tgv

	END CLASS

	CLASS IntKeyIntList
		PROTECT kvp AS KeyValuePair<INT, List<INT> >

		PROPERTY Key AS INT
			GET
				RETURN SELF:kvp:Key
			END GET
		END PROPERTY

		PROPERTY ListValue AS INT[]
			GET
				RETURN SELF:kvp:@@Value:ToArray()
			END GET
		END PROPERTY

		CONSTRUCTOR(i AS INT)
			SUPER()
			SELF:kvp := KeyValuePair<INT, List<INT> >{i, List<INT>{}}
		RETURN

		METHOD Add(i AS INT) AS VOID
			SELF:kvp:@@Value:Add(i)
		RETURN

		METHOD AddRange(range AS IEnumerable<INT>) AS VOID
			SELF:kvp:@@Value:AddRange(range)
		RETURN
 
	END CLASS

	CLASS StrKeyIntList
		PROTECT kvp AS KeyValuePair<STRING, List<INT> >

		CONSTRUCTOR(s AS STRING)
			SUPER()
			SELF:kvp := KeyValuePair<STRING, List<INT> >{s, List<INT>{}}
		RETURN

		PROPERTY Key AS STRING
			GET
				RETURN SELF:kvp:Key
			END GET
		END PROPERTY

		PROPERTY @@Value AS INT[]
			GET
				RETURN SELF:kvp:@@Value:ToArray()
			END GET
		END PROPERTY

		METHOD Add(i AS INT) AS VOID
			SELF:kvp:@@Value:Add(i)
		RETURN

		METHOD AddRange(range AS IEnumerable<INT>) AS VOID
			SELF:kvp:@@Value:AddRange(range)
		RETURN
 
	END CLASS


END NAMESPACE

